/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package exo2;

import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author courtieu
 */
public class Question2_solutionTest {
    
    public Question2_solutionTest() {
    }

    /**
     * Test de estTrie.
     * Cas testé: tableau vide.
     */
    @Test
    public void testEstTrieVide() {
        System.out.println("estTrieVide");
        int[] t = {};
        boolean expResult = true;
        boolean result = Question2_solution.estTrie(t);
        assertEquals(expResult, result);
    }
    
    /**
     * Test de estTrie.
     * Cas testé: tableau null.
     */
    @Test(expected=NullPointerException.class)
    public void testEstTrieNull() {
        System.out.println("estTrieNull");
        int[] t = null;
        boolean result = Question2_solution.estTrie(t);
    }

    /**
     * Test de estTrie.
     * Cas testé: tableau à 1 case.
     */
    @Test
    public void testEstTrieSingleton() {
        System.out.println("estTrieSingleton");
        int[] t = { 1 };
        boolean expResult = true;
        boolean result = Question2_solution.estTrie(t);
        assertEquals(expResult, result);
    }

    /**
     * Test de estTrie.
     * Cas testé: tableau à 2 éléments trié strictement.
     */
    @Test
    public void testEstTriePaireStrict() {
        System.out.println("estTriePaireStrict");
        int[] t = { 1, 2};
        boolean expResult = true;
        boolean result = Question2_solution.estTrie(t);
        assertEquals(expResult, result);
    }

    /**
     * Test de estTrie.
     * Cas testé: tableau à 2 éléments trié mais pas strictement.
     */
    @Test
    public void testEstTriePaireEq() {
        System.out.println("estTriePaireEq");
        int[] t = { 1, 1};
        boolean expResult = true;
        boolean result = Question2_solution.estTrie(t);
        assertEquals(expResult, result);
    }

    /**
     * Test de estTrie.
     * Cas testé: tableau à 2 éléments non trié
     */
    @Test
    public void testEstTriePaireWrong() {
        System.out.println("estTriePaireStrict");
        int[] t = { 2, 1};
        boolean expResult = false;
        boolean result = Question2_solution.estTrie(t);
        assertEquals(expResult, result);
    }

    /**
     * Test de estTrie.
     * Cas testé: tableau à 3 éléments triés strictement.
     */
    @Test
    public void testEstTrie3Strict() {
        System.out.println("estTrie3Strict");
        int[] t = {1,2,3};
        boolean expResult = true;
        boolean result = Question2_solution.estTrie(t);
        assertEquals(expResult, result);
    }

    /**
     * Test de estTrie.
     * Cas testé: tableau à 3 éléments triés strictement.
     */
    @Test
    public void testEstTrie3Eq() {
        System.out.println("estTrie3Eq");
        int[] t = {2,2,2};
        boolean expResult = true;
        boolean result = Question2_solution.estTrie(t);
        assertEquals(expResult, result);
    }

    // On essaie d'être exhaustif sur les tableaux de taille 4

    /**
     * Test de estTrie.
     * Cas testé: tableau à 4 éléments triés strictement.
     */
    @Test
    public void testEstTrie4Strinct() {
        System.out.println("estTrie4Strict");
        int[] t = { 1,2,3,4 };
        boolean expResult = true;
        boolean result = Question2_solution.estTrie(t);
        assertEquals(expResult, result);
    }

    /**
     * Test de estTrie.
     * Cas testé: tableau à 3 éléments triés dont 2 égaux au début.
     */
    @Test
    public void testEstTrie4Eq1() {
        System.out.println("estTrie");
        int[] t = { 1,1,3,4 };
        boolean expResult = true;
        boolean result = Question2_solution.estTrie(t);
        assertEquals(expResult, result);
    }
    
    /**
     * Test de estTrie.
     * Cas testé: tableau à 3 éléments triés dont 2 égaux à la fin.
     */
    @Test
    public void testEstTrie4EqEnd() {
        System.out.println("estTrie");
        int[] t = { 1,2,4,4 };
        boolean expResult = true;
        boolean result = Question2_solution.estTrie(t);
        assertEquals(expResult, result);
    }

    /**
     * Test de estTrie.
     * Cas testé: tableau à 3 éléments triés dont 2 égaux au milieu.
     */
    @Test
    public void testEstTrie4EqMid() {
        System.out.println("estTrie");
        int[] t = { 1,2,2,4 };
        boolean expResult = true;
        boolean result = Question2_solution.estTrie(t);
        assertEquals(expResult, result);
    }

    /**
     * Test de estTrie.
     * Cas testé: tableau à 4 éléments dont 2 non triés au mileu.
     */
    @Test
    public void testEstTrie4EqMidWrong() {
        System.out.println("testEstTrie4EqMidWrong");
        int[] t = { 1,2,1,3 };
        boolean expResult = false;
        boolean result = Question2_solution.estTrie(t);
        assertEquals(expResult, result);
    }

    /**
     * Test de estTrie.
     * Cas testé: tableau à 4 éléments dont 2 non triés à la fin.
     */
    @Test
    public void testEstTrie4EqEndWrong() {
        System.out.println("testEstTrie4EqEndWrong");
        int[] t = { 1,2,3,2 };
        boolean expResult = false;
        boolean result = Question2_solution.estTrie(t);
        assertEquals(expResult, result);
    }

    /**
     * Test de estTrie.
     * Cas testé: tableau à 4 éléments dont 2 non triés au début.
     */
    @Test
    public void testEstTrie4EqBegWrong() {
        System.out.println("testEstTrie4EqBegWrong");
        int[] t = { 2,1,3,4 };
        boolean expResult = false;
        boolean result = Question2_solution.estTrie(t);
        assertEquals(expResult, result);
    }


    // On teste de la même façon pour 5 cases, au cas où le nombre impaire
    // de cases pose problème
    
        /**
     * Test de estTrie.
     * Cas testé: tableau à 5 éléments triés strictement.
     */
    @Test
    public void testEstTrie5Strinct() {
        System.out.println("estTrie5Strict");
        int[] t = { 1,2,3,5,6 };
        boolean expResult = true;
        boolean result = Question2_solution.estTrie(t);
        assertEquals(expResult, result);
    }

    /**
     * Test de estTrie.
     * Cas testé: tableau à 3 éléments triés dont 2 égaux au début.
     */
    @Test
    public void testEstTrie5Eq1() {
        System.out.println("estTrie");
        int[] t = { 1,1,3,5,6 };
        boolean expResult = true;
        boolean result = Question2_solution.estTrie(t);
        assertEquals(expResult, result);
    }
    
    /**
     * Test de estTrie.
     * Cas testé: tableau à 3 éléments triés dont 2 égaux à la fin.
     */
    @Test
    public void testEstTrie5EqEnd() {
        System.out.println("estTrie");
        int[] t = { 1,2,4,5,5 };
        boolean expResult = true;
        boolean result = Question2_solution.estTrie(t);
        assertEquals(expResult, result);
    }

    /**
     * Test de estTrie.
     * Cas testé: tableau à 3 éléments triés dont 2 égaux au milieu.
     */
    @Test
    public void testEstTrie5EqMid() {
        System.out.println("estTrie");
        int[] t = { 1,2,2,5,6 };
        boolean expResult = true;
        boolean result = Question2_solution.estTrie(t);
        assertEquals(expResult, result);
    }

    /**
     * Test de estTrie.
     * Cas testé: tableau à 5 éléments dont 2 non triés au mileu.
     */
    @Test
    public void testEstTrie5EqMidWrong() {
        System.out.println("testEstTrie5EqMidWrong");
        int[] t = { 1,2,1,4,5 };
        boolean expResult = false;
        boolean result = Question2_solution.estTrie(t);
        assertEquals(expResult, result);
    }

    /**
     * Test de estTrie.
     * Cas testé: tableau à 5 éléments dont 2 non triés à la fin.
     */
    @Test
    public void testEstTrie5EqEndWrong() {
        System.out.println("testEstTrie5EqEndWrong");
        int[] t = { 1,2,3,4,2 };
        boolean expResult = false;
        boolean result = Question2_solution.estTrie(t);
        assertEquals(expResult, result);
    }

    /**
     * Test de estTrie.
     * Cas testé: tableau à 5 éléments dont 2 non triés au début.
     */
    @Test
    public void testEstTrie5EqBegWrong() {
        System.out.println("testEstTrie5EqBegWrong");
        int[] t = { 2,1,3,4,5 };
        boolean expResult = false;
        boolean result = Question2_solution.estTrie(t);
        assertEquals(expResult, result);
    }

}
